//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Mon Feb 26 14:36:17 2018
// Version: PolarFire v2.0 12.200.0.20
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// DisplayEnhancement_0
module DisplayEnhancement_0(
    // Inputs
    Cb_i,
    Cr_i,
    RESET_N_I,
    VIDEO_CLOCK_I,
    Y_i,
    brightness_i,
    contrast_i,
    cos_value_i,
    cos_write_addr_i,
    cos_write_en_i,
    data_enable_i,
    hactive_i,
    horz_sync_i,
    hue_i,
    mem_write_clock,
    saturation_i,
    sin_value_i,
    sin_write_addr_i,
    sin_write_en_i,
    vactive_i,
    vert_sync_i,
    // Outputs
    Cb_out_o,
    Cr_out_o,
    Y_out_o,
    data_enable_o,
    hactive_o,
    horz_sync_o,
    vactive_o,
    vert_sync_o
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input  [7:0] Cb_i;
input  [7:0] Cr_i;
input        RESET_N_I;
input        VIDEO_CLOCK_I;
input  [7:0] Y_i;
input  [7:0] brightness_i;
input  [7:0] contrast_i;
input  [9:0] cos_value_i;
input  [7:0] cos_write_addr_i;
input        cos_write_en_i;
input        data_enable_i;
input        hactive_i;
input        horz_sync_i;
input  [8:0] hue_i;
input        mem_write_clock;
input  [7:0] saturation_i;
input  [9:0] sin_value_i;
input  [7:0] sin_write_addr_i;
input        sin_write_en_i;
input        vactive_i;
input        vert_sync_i;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output [7:0] Cb_out_o;
output [7:0] Cr_out_o;
output [7:0] Y_out_o;
output       data_enable_o;
output       hactive_o;
output       horz_sync_o;
output       vactive_o;
output       vert_sync_o;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire   [7:0] brightness_i;
wire   [7:0] Cb_i;
wire   [7:0] Cb_out_o_net_0;
wire   [7:0] contrast_i;
wire   [9:0] cos_value_i;
wire   [7:0] cos_write_addr_i;
wire         cos_write_en_i;
wire   [7:0] Cr_i;
wire   [7:0] Cr_out_o_net_0;
wire         data_enable_i;
wire         data_enable_o_net_0;
wire         hactive_i;
wire         hactive_o_net_0;
wire         horz_sync_i;
wire         horz_sync_o_net_0;
wire   [8:0] hue_i;
wire         mem_write_clock;
wire         RESET_N_I;
wire   [7:0] saturation_i;
wire   [9:0] sin_value_i;
wire   [7:0] sin_write_addr_i;
wire         sin_write_en_i;
wire         vactive_i;
wire         vactive_o_net_0;
wire         vert_sync_i;
wire         vert_sync_o_net_0;
wire         VIDEO_CLOCK_I;
wire   [7:0] Y_i;
wire   [7:0] Y_out_o_net_0;
wire         data_enable_o_net_1;
wire         horz_sync_o_net_1;
wire         vert_sync_o_net_1;
wire         hactive_o_net_1;
wire         vactive_o_net_1;
wire   [7:0] Y_out_o_net_1;
wire   [7:0] Cb_out_o_net_1;
wire   [7:0] Cr_out_o_net_1;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign data_enable_o_net_1 = data_enable_o_net_0;
assign data_enable_o       = data_enable_o_net_1;
assign horz_sync_o_net_1   = horz_sync_o_net_0;
assign horz_sync_o         = horz_sync_o_net_1;
assign vert_sync_o_net_1   = vert_sync_o_net_0;
assign vert_sync_o         = vert_sync_o_net_1;
assign hactive_o_net_1     = hactive_o_net_0;
assign hactive_o           = hactive_o_net_1;
assign vactive_o_net_1     = vactive_o_net_0;
assign vactive_o           = vactive_o_net_1;
assign Y_out_o_net_1       = Y_out_o_net_0;
assign Y_out_o[7:0]        = Y_out_o_net_1;
assign Cb_out_o_net_1      = Cb_out_o_net_0;
assign Cb_out_o[7:0]       = Cb_out_o_net_1;
assign Cr_out_o_net_1      = Cr_out_o_net_0;
assign Cr_out_o[7:0]       = Cr_out_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------DisplayEnhancements   -   Microsemi:SolutionCore:DisplayEnhancements:2.0.0
DisplayEnhancements #( 
        .g_B_C_SAT_CONSTANT_WIDTH ( 8 ),
        .g_HUE_CONSTANT_WIDTH     ( 9 ),
        .g_SIN_COS_DWIDTH         ( 10 ),
        .g_SIN_COS_MEM_DEPTH      ( 180 ),
        .g_YCbCr_DATA_BIT_WIDTH   ( 8 ) )
DisplayEnhancement_0_0(
        // Inputs
        .VIDEO_CLOCK_I    ( VIDEO_CLOCK_I ),
        .mem_write_clock  ( mem_write_clock ),
        .RESET_N_I        ( RESET_N_I ),
        .brightness_i     ( brightness_i ),
        .contrast_i       ( contrast_i ),
        .saturation_i     ( saturation_i ),
        .hue_i            ( hue_i ),
        .sin_write_en_i   ( sin_write_en_i ),
        .cos_write_en_i   ( cos_write_en_i ),
        .sin_write_addr_i ( sin_write_addr_i ),
        .cos_write_addr_i ( cos_write_addr_i ),
        .sin_value_i      ( sin_value_i ),
        .cos_value_i      ( cos_value_i ),
        .Y_i              ( Y_i ),
        .Cb_i             ( Cb_i ),
        .Cr_i             ( Cr_i ),
        .data_enable_i    ( data_enable_i ),
        .horz_sync_i      ( horz_sync_i ),
        .vert_sync_i      ( vert_sync_i ),
        .hactive_i        ( hactive_i ),
        .vactive_i        ( vactive_i ),
        // Outputs
        .Y_out_o          ( Y_out_o_net_0 ),
        .Cb_out_o         ( Cb_out_o_net_0 ),
        .Cr_out_o         ( Cr_out_o_net_0 ),
        .data_enable_o    ( data_enable_o_net_0 ),
        .horz_sync_o      ( horz_sync_o_net_0 ),
        .vert_sync_o      ( vert_sync_o_net_0 ),
        .hactive_o        ( hactive_o_net_0 ),
        .vactive_o        ( vactive_o_net_0 ) 
        );


endmodule
