----------------------------------------------------------------------
-- Created by SmartDesign Wed Aug 12 08:45:38 2020
-- Version: v12.4 12.900.0.16
----------------------------------------------------------------------

----------------------------------------------------------------------
-- Libraries
----------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

library polarfire;
use polarfire.all;
----------------------------------------------------------------------
-- RGB2YCbCr_IP0 entity declaration
----------------------------------------------------------------------
entity RGB2YCbCr_IP0 is
    -- Port list
    port(
        -- Inputs
        BLUE_I       : in  std_logic_vector(7 downto 0);
        CLOCK_I      : in  std_logic;
        DATA_VALID_I : in  std_logic;
        GREEN_I      : in  std_logic_vector(7 downto 0);
        RED_I        : in  std_logic_vector(7 downto 0);
        RESET_N_I    : in  std_logic;
        -- Outputs
        Cb_OUT_O     : out std_logic_vector(7 downto 0);
        Cr_OUT_O     : out std_logic_vector(7 downto 0);
        DATA_VALID_O : out std_logic;
        Y_OUT_O      : out std_logic_vector(7 downto 0)
        );
end RGB2YCbCr_IP0;
----------------------------------------------------------------------
-- RGB2YCbCr_IP0 architecture body
----------------------------------------------------------------------
architecture RTL of RGB2YCbCr_IP0 is
----------------------------------------------------------------------
-- Component declarations
----------------------------------------------------------------------
-- RGB2YCbCr   -   Microsemi:SolutionCore:RGB2YCbCr:3.0.1
component RGB2YCbCr
    generic( 
        G_RGB_DATA_BIT_WIDTH   : integer := 8 ;
        G_YCbCr_DATA_BIT_WIDTH : integer := 8 
        );
    -- Port list
    port(
        -- Inputs
        BLUE_I       : in  std_logic_vector(7 downto 0);
        CLOCK_I      : in  std_logic;
        DATA_VALID_I : in  std_logic;
        GREEN_I      : in  std_logic_vector(7 downto 0);
        RED_I        : in  std_logic_vector(7 downto 0);
        RESET_N_I    : in  std_logic;
        -- Outputs
        Cb_OUT_O     : out std_logic_vector(7 downto 0);
        Cr_OUT_O     : out std_logic_vector(7 downto 0);
        DATA_VALID_O : out std_logic;
        Y_OUT_O      : out std_logic_vector(7 downto 0)
        );
end component;
----------------------------------------------------------------------
-- Signal declarations
----------------------------------------------------------------------
signal DATA_VALID_O_net_0 : std_logic;
signal net_0              : std_logic_vector(7 downto 0);
signal net_1              : std_logic_vector(7 downto 0);
signal net_2              : std_logic_vector(7 downto 0);
signal net_0_net_0        : std_logic_vector(7 downto 0);
signal net_1_net_0        : std_logic_vector(7 downto 0);
signal net_2_net_0        : std_logic_vector(7 downto 0);
signal DATA_VALID_O_net_1 : std_logic;

begin
----------------------------------------------------------------------
-- Top level output port assignments
----------------------------------------------------------------------
 net_0_net_0          <= net_0;
 Y_OUT_O(7 downto 0)  <= net_0_net_0;
 net_1_net_0          <= net_1;
 Cb_OUT_O(7 downto 0) <= net_1_net_0;
 net_2_net_0          <= net_2;
 Cr_OUT_O(7 downto 0) <= net_2_net_0;
 DATA_VALID_O_net_1   <= DATA_VALID_O_net_0;
 DATA_VALID_O         <= DATA_VALID_O_net_1;
----------------------------------------------------------------------
-- Component instances
----------------------------------------------------------------------
-- RGB2YCbCr_IP0_0   -   Microsemi:SolutionCore:RGB2YCbCr:3.0.1
RGB2YCbCr_IP0_0 : RGB2YCbCr
    generic map( 
        G_RGB_DATA_BIT_WIDTH   => ( 8 ),
        G_YCbCr_DATA_BIT_WIDTH => ( 8 )
        )
    port map( 
        -- Inputs
        CLOCK_I      => CLOCK_I,
        RESET_N_I    => RESET_N_I,
        RED_I        => RED_I,
        GREEN_I      => GREEN_I,
        BLUE_I       => BLUE_I,
        DATA_VALID_I => DATA_VALID_I,
        -- Outputs
        Y_OUT_O      => net_0,
        Cb_OUT_O     => net_1,
        Cr_OUT_O     => net_2,
        DATA_VALID_O => DATA_VALID_O_net_0 
        );

end RTL;
