//////////////////////////////////////////////////////////////////////
// Created by SmartDesign Wed Aug 12 08:40:43 2020
// Version: v12.4 12.900.0.16
//////////////////////////////////////////////////////////////////////

`timescale 1ns / 100ps

// cam_ar0331_mipi
module cam_ar0331_mipi(
    // Inputs
    PADN,
    PADP,
    PAD_I_N,
    PAD_I_P,
    reset_mipi,
    // Outputs
    L1_LP_DATA,
    L1_LP_DATA_N,
    L2_LP_DATA,
    L2_LP_DATA_N,
    L3_LP_DATA,
    L3_LP_DATA_N,
    PLL_LOCK_0,
    data_out_o,
    frame_end,
    frame_start,
    line_end,
    line_start,
    line_valid_o,
    parallel_clock
);

//--------------------------------------------------------------------
// Input
//--------------------------------------------------------------------
input        PADN;
input        PADP;
input  [3:0] PAD_I_N;
input  [3:0] PAD_I_P;
input        reset_mipi;
//--------------------------------------------------------------------
// Output
//--------------------------------------------------------------------
output       L1_LP_DATA;
output       L1_LP_DATA_N;
output       L2_LP_DATA;
output       L2_LP_DATA_N;
output       L3_LP_DATA;
output       L3_LP_DATA_N;
output       PLL_LOCK_0;
output [7:0] data_out_o;
output       frame_end;
output       frame_start;
output       line_end;
output       line_start;
output       line_valid_o;
output       parallel_clock;
//--------------------------------------------------------------------
// Nets
//--------------------------------------------------------------------
wire         AND2_0_Y_2;
wire   [7:0] data_out_o_net_0;
wire         debounce_rst_0_rst_i;
wire         frame_end_net_0;
wire         frame_start_net_0;
wire         L1_LP_DATA_net_0;
wire         L1_LP_DATA_N_net_0;
wire         L2_LP_DATA_net_0;
wire         L2_LP_DATA_N_net_0;
wire         L3_LP_DATA_net_0;
wire         L3_LP_DATA_N_net_0;
wire         line_end_net_0;
wire         line_start_net_0;
wire         line_valid_o_net_0;
wire         MIPI_RX_IOD_0_L0_LP_DATA;
wire         MIPI_RX_IOD_0_L0_LP_DATA_N;
wire   [7:0] MIPI_RX_IOD_0_L0_RXD_DATA;
wire   [7:0] MIPI_RX_IOD_0_L1_RXD_DATA;
wire   [7:0] MIPI_RX_IOD_0_L2_RXD_DATA;
wire   [7:0] MIPI_RX_IOD_0_L3_RXD_DATA;
wire         MIPI_RX_IOD_0_RX_CLK_G;
wire   [3:0] PAD_I_N;
wire   [3:0] PAD_I_P;
wire         PADN;
wire         PADP;
wire         parallel_clock_0;
wire         PF_CCC_0_OUT0_FABCLK_0;
wire         reset_mipi;
wire         reset_mipi_net_0;
wire         frame_start_net_1;
wire         line_start_net_1;
wire         frame_end_net_1;
wire         line_end_net_1;
wire         line_valid_o_net_1;
wire         parallel_clock_0_net_0;
wire         L3_LP_DATA_N_net_1;
wire         L1_LP_DATA_N_net_1;
wire         L2_LP_DATA_net_1;
wire         L3_LP_DATA_net_1;
wire         L1_LP_DATA_net_1;
wire         L2_LP_DATA_N_net_1;
wire   [7:0] data_out_o_net_1;
//--------------------------------------------------------------------
// TiedOff Nets
//--------------------------------------------------------------------
wire         VCC_net;
wire   [3:0] EYE_MONITOR_CLEAR_FLAGS_const_net_0;
wire   [3:0] DELAY_LINE_MOVE_const_net_0;
wire   [3:0] DELAY_LINE_DIRECTION_const_net_0;
wire   [3:0] DELAY_LINE_LOAD_const_net_0;
wire         GND_net;
wire   [2:0] EYE_MONITOR_WIDTH_const_net_0;
wire   [10:0]DRI_CTRL_0_const_net_0;
wire   [32:0]DRI_WDATA_0_const_net_0;
wire   [10:0]DRI_CTRL_1_const_net_0;
wire   [32:0]DRI_WDATA_1_const_net_0;
wire   [10:0]DLL_DRI_CTRL_const_net_0;
wire   [32:0]DLL_DRI_WDATA_const_net_0;
//--------------------------------------------------------------------
// Constant assignments
//--------------------------------------------------------------------
assign VCC_net                             = 1'b1;
assign EYE_MONITOR_CLEAR_FLAGS_const_net_0 = 4'h0;
assign DELAY_LINE_MOVE_const_net_0         = 4'h0;
assign DELAY_LINE_DIRECTION_const_net_0    = 4'h0;
assign DELAY_LINE_LOAD_const_net_0         = 4'h0;
assign GND_net                             = 1'b0;
assign EYE_MONITOR_WIDTH_const_net_0       = 3'h0;
assign DRI_CTRL_0_const_net_0              = 11'h000;
assign DRI_WDATA_0_const_net_0             = 33'h000000000;
assign DRI_CTRL_1_const_net_0              = 11'h000;
assign DRI_WDATA_1_const_net_0             = 33'h000000000;
assign DLL_DRI_CTRL_const_net_0            = 11'h000;
assign DLL_DRI_WDATA_const_net_0           = 33'h000000000;
//--------------------------------------------------------------------
// Top level output port assignments
//--------------------------------------------------------------------
assign reset_mipi_net_0       = reset_mipi;
assign PLL_LOCK_0             = reset_mipi_net_0;
assign frame_start_net_1      = frame_start_net_0;
assign frame_start            = frame_start_net_1;
assign line_start_net_1       = line_start_net_0;
assign line_start             = line_start_net_1;
assign frame_end_net_1        = frame_end_net_0;
assign frame_end              = frame_end_net_1;
assign line_end_net_1         = line_end_net_0;
assign line_end               = line_end_net_1;
assign line_valid_o_net_1     = line_valid_o_net_0;
assign line_valid_o           = line_valid_o_net_1;
assign parallel_clock_0_net_0 = parallel_clock_0;
assign parallel_clock         = parallel_clock_0_net_0;
assign L3_LP_DATA_N_net_1     = L3_LP_DATA_N_net_0;
assign L3_LP_DATA_N           = L3_LP_DATA_N_net_1;
assign L1_LP_DATA_N_net_1     = L1_LP_DATA_N_net_0;
assign L1_LP_DATA_N           = L1_LP_DATA_N_net_1;
assign L2_LP_DATA_net_1       = L2_LP_DATA_net_0;
assign L2_LP_DATA             = L2_LP_DATA_net_1;
assign L3_LP_DATA_net_1       = L3_LP_DATA_net_0;
assign L3_LP_DATA             = L3_LP_DATA_net_1;
assign L1_LP_DATA_net_1       = L1_LP_DATA_net_0;
assign L1_LP_DATA             = L1_LP_DATA_net_1;
assign L2_LP_DATA_N_net_1     = L2_LP_DATA_N_net_0;
assign L2_LP_DATA_N           = L2_LP_DATA_N_net_1;
assign data_out_o_net_1       = data_out_o_net_0;
assign data_out_o[7:0]        = data_out_o_net_1;
//--------------------------------------------------------------------
// Component instances
//--------------------------------------------------------------------
//--------AND2
AND2 AND2_0(
        // Inputs
        .A ( debounce_rst_0_rst_i ),
        .B ( VCC_net ),
        // Outputs
        .Y ( AND2_0_Y_2 ) 
        );

//--------debounce_rst
debounce_rst debounce_rst_0(
        // Inputs
        .i_clk      ( parallel_clock_0 ),
        .RESET_N    ( VCC_net ),
        .i_dip1_rst ( reset_mipi ),
        // Outputs
        .rst_i      ( debounce_rst_0_rst_i ) 
        );

//--------MIPI_CSI2_RX_PF_IP0
MIPI_CSI2_RX_PF_IP0 MIPI_CSI2_RX_PF_IP0_0(
        // Inputs
        .CAM_CLOCK_I      ( PF_CCC_0_OUT0_FABCLK_0 ),
        .PARALLEL_CLOCK_I ( parallel_clock_0 ),
        .RESET_n_I        ( AND2_0_Y_2 ),
        .L0_LP_DATA_I     ( MIPI_RX_IOD_0_L0_LP_DATA ),
        .L0_LP_DATA_N_I   ( MIPI_RX_IOD_0_L0_LP_DATA_N ),
        .L1_LP_DATA_I     ( L1_LP_DATA_net_0 ),
        .L1_LP_DATA_N_I   ( L1_LP_DATA_N_net_0 ),
        .L2_LP_DATA_I     ( L2_LP_DATA_net_0 ),
        .L2_LP_DATA_N_I   ( L2_LP_DATA_N_net_0 ),
        .L3_LP_DATA_I     ( L3_LP_DATA_net_0 ),
        .L3_LP_DATA_N_I   ( L3_LP_DATA_N_net_0 ),
        .L0_HS_DATA_I     ( MIPI_RX_IOD_0_L0_RXD_DATA ),
        .L1_HS_DATA_I     ( MIPI_RX_IOD_0_L1_RXD_DATA ),
        .L2_HS_DATA_I     ( MIPI_RX_IOD_0_L2_RXD_DATA ),
        .L3_HS_DATA_I     ( MIPI_RX_IOD_0_L3_RXD_DATA ),
        // Outputs
        .frame_end_o      ( frame_end_net_0 ),
        .frame_start_o    ( frame_start_net_0 ),
        .line_end_o       ( line_end_net_0 ),
        .line_start_o     ( line_start_net_0 ),
        .line_valid_o     ( line_valid_o_net_0 ),
        .data_out_o       ( data_out_o_net_0 ),
        .word_count_o     (  ),
        .frame_valid_o    (  ) 
        );

//--------IOD_MIPI_RX
IOD_MIPI_RX MIPI_RX_IOD_0(
        // Inputs
        .RX_CLK_P                ( PADP ),
        .RX_CLK_N                ( PADN ),
        .RXD                     ( PAD_I_P ),
        .RXD_N                   ( PAD_I_N ),
        .HS_SEL                  ( VCC_net ),
        .EYE_MONITOR_CLEAR_FLAGS ( EYE_MONITOR_CLEAR_FLAGS_const_net_0 ),
        .DELAY_LINE_MOVE         ( DELAY_LINE_MOVE_const_net_0 ),
        .DELAY_LINE_DIRECTION    ( DELAY_LINE_DIRECTION_const_net_0 ),
        .DELAY_LINE_LOAD         ( DELAY_LINE_LOAD_const_net_0 ),
        .RX_BIT_SLIP_0           ( GND_net ),
        .RX_BIT_SLIP_1           ( GND_net ),
        .RX_BIT_SLIP_2           ( GND_net ),
        .RX_BIT_SLIP_3           ( GND_net ),
        .ARST_N                  ( VCC_net ),
        .HS_IO_CLK_PAUSE         ( GND_net ),
        .EYE_MONITOR_WIDTH       ( EYE_MONITOR_WIDTH_const_net_0 ),
        // Outputs
        .L0_RXD_DATA             ( MIPI_RX_IOD_0_L0_RXD_DATA ),
        .L1_RXD_DATA             ( MIPI_RX_IOD_0_L1_RXD_DATA ),
        .L2_RXD_DATA             ( MIPI_RX_IOD_0_L2_RXD_DATA ),
        .L3_RXD_DATA             ( MIPI_RX_IOD_0_L3_RXD_DATA ),
        .L0_LP_DATA              ( MIPI_RX_IOD_0_L0_LP_DATA ),
        .L0_LP_DATA_N            ( MIPI_RX_IOD_0_L0_LP_DATA_N ),
        .L1_LP_DATA              ( L1_LP_DATA_net_0 ),
        .L1_LP_DATA_N            ( L1_LP_DATA_N_net_0 ),
        .L2_LP_DATA              ( L2_LP_DATA_net_0 ),
        .L2_LP_DATA_N            ( L2_LP_DATA_N_net_0 ),
        .L3_LP_DATA              ( L3_LP_DATA_net_0 ),
        .L3_LP_DATA_N            ( L3_LP_DATA_N_net_0 ),
        .RX_CLK_G                ( MIPI_RX_IOD_0_RX_CLK_G ),
        .EYE_MONITOR_EARLY       (  ),
        .EYE_MONITOR_LATE        (  ),
        .DELAY_LINE_OUT_OF_RANGE (  ),
        .CLK_TRAIN_DONE          (  ),
        .CLK_TRAIN_ERROR         (  ) 
        );

//--------cam_ar0331_mipi_PF_CCC_0_PF_CCC   -   Actel:SgCore:PF_CCC:2.2.100
cam_ar0331_mipi_PF_CCC_0_PF_CCC PF_CCC_0(
        // Inputs
        .REF_CLK_0     ( MIPI_RX_IOD_0_RX_CLK_G ),
        // Outputs
        .OUT0_FABCLK_0 ( PF_CCC_0_OUT0_FABCLK_0 ),
        .OUT1_FABCLK_0 ( parallel_clock_0 ),
        .PLL_LOCK_0    (  ) 
        );


endmodule
